package org.netkernel.rdf.jena.endpoint;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.rdf.jena.rep.JenaModelRepresentation;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;

public class RDFParserAccessor extends StandardAccessorImpl
{
	public RDFParserAccessor()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	Model m=ModelFactory.createDefaultModel();
		IReadableBinaryStreamRepresentation opd=context.source("arg:operand", IReadableBinaryStreamRepresentation.class);
		String base=context.getThisRequest().getArgumentValue("base"); //The Base URI from which to resolve relatives - null if doesn't exist.
		String type=context.getThisRequest().getArgumentValue("activeType");
		if(type.equals("jRDFParseXML"))
		{	m=m.read(opd.getInputStream(),base);
		}
		else if (type.equals("jRDFParseN3"))
		{	m=m.read(opd.getInputStream(),base,"N3");
		}
		else if (type.equals("jRDFParseN-Triple"))
		{	m=m.read(opd.getInputStream(),base,"N-TRIPLE");
		}
		else if (type.equals("jRDFParseTURTLE"))
		{	m=m.read(opd.getInputStream(),base,"TURTLE");
		}
		JenaModelRepresentation jmr=new JenaModelRepresentation(m);
		context.createResponseFrom(jmr);
	}
}
